> For the complete documentation index, see [llms.txt](https://docs.enclaive.cloud/vault/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.enclaive.cloud/vault/api/secrets-engines/cubbyhole-secrets-engine-api.md).

# Cubbyhole secrets engine (API)

This is the API documentation for the Vault Cubbyhole secrets engine. For general information about the usage and operation of the Cubbyhole secrets engine, please see the Vault Cubbyhole documentation.

This documentation assumes the Cubbyhole secrets engine is enabled at the `/cubbyhole` path in Vault. Since it is possible to enable secrets engines at any location, please update your API calls accordingly.

### Read secret <a href="#read-secret" id="read-secret"></a>

This endpoint retrieves the secret at the specified location.

| Method | Path               |
| ------ | ------------------ |
| `GET`  | `/cubbyhole/:path` |

#### Parameters <a href="#parameters" id="parameters"></a>

* `path` `(string: <required>)` – Specifies the path of the secret to read. This is specified as part of the URL.

#### Sample request <a href="#sample-request" id="sample-request"></a>

```shell-session
$ curl \
    --header "X-Vault-Token: ..." \
    http://127.0.0.1:8200/v1/cubbyhole/my-secret
```

#### Sample response <a href="#sample-response" id="sample-response"></a>

```json
{
  "auth": null,
  "data": {
    "foo": "bar"
  },
  "lease_duration": 0,
  "lease_id": "",
  "renewable": false
}
```

### List secrets <a href="#list-secrets" id="list-secrets"></a>

This endpoint returns a list of secret entries at the specified location. Folders are suffixed with `/`. The input must be a folder; list on a file will not return a value. The values themselves are not accessible via this command.

| Method | Path               |
| ------ | ------------------ |
| `LIST` | `/cubbyhole/:path` |

#### Parameters <a href="#parameters-1" id="parameters-1"></a>

* `path` `(string: <required>)` – Specifies the path of the secrets to list. This is specified as part of the URL.

#### Sample request <a href="#sample-request-1" id="sample-request-1"></a>

```shell-session
$ curl \
    --header "X-Vault-Token: ..." \
    --request LIST \
    http://127.0.0.1:8200/v1/cubbyhole/my-secret
```

#### Sample response <a href="#sample-response-1" id="sample-response-1"></a>

The example below shows output for a query path of `cubbyhole/` when there are secrets at `cubbyhole/foo` and `cubbyhole/foo/bar`; note the difference in the two entries.

```json
{
  "auth": null,
  "data": {
    "keys": ["foo", "foo/"]
  },
  "lease_duration": 2764800,
  "lease_id": "",
  "renewable": false
}
```

### Create/Update secret <a href="#create-update-secret" id="create-update-secret"></a>

This endpoint stores a secret at the specified location.

| Method | Path               |
| ------ | ------------------ |
| `POST` | `/cubbyhole/:path` |

#### Parameters <a href="#parameters-2" id="parameters-2"></a>

* `path` `(string: <required>)` – Specifies the path of the secrets to create/update. This is specified as part of the URL.
* `:key` `(string: "")` – Specifies a key in the payload, paired with an associated value, to be held at the given location. Multiple key/value pairs can be specified, and all will be returned on a read operation.

#### Sample payload <a href="#sample-payload" id="sample-payload"></a>

```json
{
  "foo": "bar",
  "zip": "zap"
}
```

#### Sample request <a href="#sample-request-2" id="sample-request-2"></a>

```shell-session
$ curl \
    --header "X-Vault-Token: ..." \
    --request POST \
    --data @payload.json \
    http://127.0.0.1:8200/v1/cubbyhole/my-secret
```

### Delete secret <a href="#delete-secret" id="delete-secret"></a>

This endpoint deletes the secret at the specified location.

| Method   | Path               |
| -------- | ------------------ |
| `DELETE` | `/cubbyhole/:path` |

#### Parameters <a href="#parameters-3" id="parameters-3"></a>

* `path` `(string: <required>)` – Specifies the path of the secret to delete. This is specified as part of the URL.

#### Sample request <a href="#sample-request-3" id="sample-request-3"></a>

```shell-session
$ curl \
    --header "X-Vault-Token: ..." \
    --request DELETE \
    http://127.0.0.1:8200/v1/cubbyhole/my-secret
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.enclaive.cloud/vault/api/secrets-engines/cubbyhole-secrets-engine-api.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
